
#include <Servo.h>

Servo dummy;//rotation motor
Servo candy;//candy servo
Servo spring;//spring winder
Servo release;//fire catapult

int a=0;
int b=82;//angle to start
int c=100;//millisecond time delay rotation motor

int r=0;//storage for right photocell
int ctr=0;//storage for center photocell
int l=0;//storage for left photocell
int r1=0;//storage for last right reading
int ctr1=0;
int l1=0;
int d=1;//direction set, 0 for right, 1 center, 2 left
int smile=0;//smile holder variable  0 for frown 1 for smile

int z=30;//center adjustment value for photo resistor
int z1=7000;//speech delay

int v=700;//smile storage




void setup() {
dummy.attach(3);
dummy.write(82);//home position at candy tower

candy.attach(0);
candy.write(133);

spring.attach(2);
spring.write(30);

release.attach(1);
release.write(87);
  
  pinMode (4,OUTPUT);//right led
  pinMode (5,OUTPUT);//center led
  pinMode (6,OUTPUT);//left led
  pinMode (7,OUTPUT);//vision led
  pinMode (A0,INPUT);//analog in right
  pinMode (A1,INPUT);//analog in center
  pinMode (A2,INPUT);//analog in left
  pinMode (A3,INPUT);//vision input

  //audio setup
  pinMode(9,OUTPUT);//if you want candy pin 6 sound
  pinMode(10,OUTPUT);//no smile no candy pin 4 sound
  pinMode(11,OUTPUT);//candy coming pin 5 sound
  digitalWrite(9,HIGH);
  digitalWrite(10,HIGH);
  digitalWrite(11,HIGH);
  

  

  pinMode (A3,INPUT);//analog vision

  r=analogRead(A0);
  ctr=analogRead(A1);
  l=analogRead(A2);
  r1=r;
  ctr1=ctr;
  l1=l;

  digitalWrite(4,HIGH);//test leds on
  digitalWrite(5,HIGH);
  digitalWrite(6,HIGH);
  digitalWrite (7,HIGH);
  delay(2000);
  digitalWrite(4,LOW);
  digitalWrite(5,LOW);
  digitalWrite(6,LOW);
  digitalWrite(7,LOW);
  

  delay(5000);


  
  

}

void loop() {





r1=r;
ctr1=ctr;
l1=l;


r=analogRead(A0);
  ctr=analogRead(A1);
  l=analogRead(A2);

  if ((r1+30)<r ||(ctr1+30)<ctr ||(l1+30)<l) {

    //alex is active
    

    
delay(500);//wait for things to settle and read again
r=analogRead(A0);
  ctr=analogRead(A1);
  l=analogRead(A2);

  digitalWrite(9,LOW);//if you want candy speech
    delay(800);
    digitalWrite(9,HIGH);
    z1=3000;


//test for right
if (r>(ctr +z) && (r>l)) {
  digitalWrite (4,HIGH);//right active
  d=0;
  delay(1000);
  digitalWrite(4,LOW);
}

//test for center
if (((ctr+z)>r) && ((ctr+z)>l)) {
  digitalWrite (5,HIGH);//center active
  d=1;
  delay(1000);
  digitalWrite (5,LOW);
}

//test for left
if ((l>(ctr+z)) && (l>r)) {

 digitalWrite(6,HIGH);//left active
 d=2;
 delay(1000);
 digitalWrite(6,LOW);
}

delay(z1);//wait for speech phrase

//look for smile
v=analogRead(A3);//read vision
if ((v>540) && (v<600)) {//smile detected
  digitalWrite (7,HIGH);//turn on smile led
  smile=1;//turn on smile detected bit
  delay(1000);
  digitalWrite (7,LOW);
}



if (smile==1) {

  //speak candy coming phrase
  digitalWrite(11,LOW);
  delay(800);
  digitalWrite(11,HIGH);

  candy.write(117);//start dispensing candy
  delay(1000);
  for (int c=117; c<=133; c++) {
    candy.write(c);
    delay(200);

    //candy should be dropped
  }
delay(1000);//make sure candy is in place

  //move to fire position
  if (d==0) {//move to right fire position

    digitalWrite(4,HIGH);//show right
   for (int b=82; b>=65; b--) {
    dummy.write(b);
    delay(c); 
   }}

   if (d==1) {//move to center fire position

    digitalWrite(5,HIGH);//show center 
    for (int b=82; b<=97; b++) {//move to center position
      dummy.write(b);
      delay(c);
    }}

   if (d==2) {//move to left fire position

    digitalWrite(6,HIGH);//show left
    for (int b=82; b<=125; b++) {//move to left
      dummy.write(b);
      delay(c);
    }}
delay(1500);//wait for movement to stop

spring.write(150);//wind spring for candy release
delay(2000);
release.write(50);//release spring
delay(1000);
spring.write(30);
delay(2000);
release.write(87);
delay(1000);//catapult should be reset

    delay(3000);//temporary delay to simulate firing
//return to loading position

  if (d==0) {//move from right fire position
   for (int b=65; b<=82; b++) {
    dummy.write(b);
    delay(c); 
   }}

   if (d==1) {//move from center fire position
    for (int b=97; b>=82; b--) {//move to center position
      dummy.write(b);
      delay(c);
    }}

   if (d==2) {//move from left fire position
    for (int b=125; b>=82; b--) {//move to left
      dummy.write(b);
      delay(c);
    }}



      delay(2000);//temporary to wait in load position
   digitalWrite(4,LOW);//reset lights
   digitalWrite(5,LOW);
   digitalWrite(6,LOW);


  
}//end of smile and discharge candy section


delay(2000);//last speech must end before new trigger
if (smile==0) {

  //speak no smile no candy
  digitalWrite(10,LOW);
  delay(1000);
  digitalWrite(10,HIGH);
  delay(6000);
  
}

smile=0;//reset smile bit

}

}



  





